// Clavier RTTY 30 touches
// Voir http://rotilom.com/F6IDT/clavier-rtty.htm

#include "Keypad.h"     // Chargement de la bibliothèque
const byte ROWS = 3;    // Trois rangées
const byte COLS = 10;   // Dix colonnes

char key;
char alpha = 1;         // Clavier en lettres au départ
uint8_t buf[8] = { 0 }; // Buffer clavier

char numberKeys[ROWS][COLS] =
{
 { 'A','Z','E','R','T','Y','U','I','O','P' },
 { 'Q','S','D','F','G','H','J','K','L','M' },
 { '#','W','X','C','V','B','N','@',' ','%' }
};
  // '#' touche pour basculer lettres/chiffres
  // ' ' touche espace
  // '@' touche ENTER
  // '%' touche BREAK (ESCAPE)

// Connexions sur l'Arduino Uno R3:
byte colPins[COLS] = {13, 12, 11, 10, 9, 8, 7, 6, 5, 4};
byte rowPins[ROWS] = {A5, A4, A3};
byte ledPin = A0;     // LED chiffres/lettres

// Initialisation:
Keypad numpad( makeKeymap(numberKeys), rowPins, colPins, sizeof(rowPins), sizeof(colPins) );
//*********************************************************    
void setup()
{
  Serial.begin(9600);
  
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, LOW);   // LED "chiffres" éteinte

  numpad.begin( makeKeymap(numberKeys) );   
}
//*********************************************************
//*********************************************************    
void loop()
{
 if (key == '#') // Bascule lettres/chiffres.
   {
      if (alpha == 1)   // Le clavier est en lettres,
       {
        alpha = 0;   // maintenant nous le voulons en chiffres
        digitalWrite(ledPin, HIGH); // et on allume la LED. 
       }
        else            // Le clavier est en chiffres,
       {
        alpha = 1;   // maintenant nous le voulons en lettres.
        digitalWrite(ledPin, LOW); // et on éteind la LED.
       }   
   }
//*********************************************************    
   key = numpad.getKey();
      if (key == 'A')       // A et 1
   {
      if (alpha == 1)       // Alpha égal à 1, nous sommes en lettres
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 20;          // Code décimal lettre A
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
     }
     else                   // Alpha différent de 1, nous sommes en chiffres
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 30;          // Code décimal chiffre 1
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'Z')       // Z et 2
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 26;          // Code décimal lettre Z
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 31;          // Code décimal Chiffre 2
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'E')       // E et 3
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 8;           // Code décimal lettre E
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 32;          // Code décimal chiffre 3
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'R')       // R et 4
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 21;          // Code décimal lettre R
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 33;          // Code décimal chiffre 4
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'T')       // T et 5
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 23;           // Code décimal lettre T
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 34;          // Code décimal chiffre 5
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'Y')       // Y et 6
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 28;           // Code décimal lettre Y
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 35;          // Code décimal chiffre 6
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'U')       // U et 7
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 24;          // Code décimal lettre U
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 36;          // Code décimal chiffre 7
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'I')       // I et 8
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 12;          // Code décimal lettre I
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 37;          // Code décimal chiffre 8
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'O')       // 0 et 9
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 18;          // Code décimal lettre O
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 38;          // Code décimal chiffre 9
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    } 
//*********************************************************    
      if (key == 'P')       // P et 0
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 19;          // Code décimal lettre P
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 39;          // Code décimal chiffre 0
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'Q')       // Q et *
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 4;           // Code décimal lettre Q
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 49;          // Code décimal de *
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
    
      if (key == 'S')       // S et &
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 22;          // Code décimal lettre S
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 30;          // Code décimal de &
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'D')       // D et !
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 7;           // Code décimal lettre D
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 56;          // Code décimal de !
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
 //*********************************************************    
      if (key == 'F')       // F et ?
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 9;           // Code décimal lettre F
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 16;          // Code décimal de ?
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }      
    }
//*********************************************************    
      if (key == 'G')       // G et (
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 10;          // Code décimal lettre G
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 34;          // Code décimal de (
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'H')  // H et )
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 11;          // Code décimal lettre H
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 45;          // Code décimal de )
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'J')       // J et /
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 13;          // Code décimal lettre J
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 55;          // Code décimal de /
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************
      if (key == 'K')       // K et +
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 14;          // Code décimal lettre K
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 46;          // Code décimal de +
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'L')       // L et -
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 15;          // Code décimal lettre L
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {      
      buf[2] = 35;          // Code décimal de -
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'M')       // M et =
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 51;          // Code décimal lettre M
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {      
      buf[2] = 46;          // Code décimal de =
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'W')       // W et '
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 29;          // Code décimal lettre W
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {      
      buf[2] = 33;          // Code décimal de '
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'X')       // X et "
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 27;          // Code décimal lettre X
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {      
      buf[2] = 32;          // Code décimal de "
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'C')       // C et :
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 6;           // Code décimal lettre C
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {      
      buf[2] = 55;          // Code décimal de :
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'V')       // V et ;
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 25;          // Code décimal lettre V
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {      
      buf[2] = 54;          // Code décimal de ;
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'B')       // B et .
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 5;           // Code décimal lettre B
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer      
      buf[2] = 54;          // Code décimal de .
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
      }
    }
//*********************************************************    
      if (key == 'N')       // N et ,
   {
      if (alpha == 1)
     {
      buf[2] = 57;          // CTRL ON passe en majuscules      
      Serial.write(buf, 8); // envoi de CTRL sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 17;          // Code décimal lettre N
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
      buf[2] = 57;          // CTRL OFF passe en minuscules
      Serial.write(buf, 8); // envoi de CTRL Sur USB
      releaseKey();         // RAZ buffer
     } 
     else
     {      
      buf[2] = 16;          // Code décimal de ,
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
     }
   }
//*********************************************************    
      if (key == ' ')       // Espace
   {
      buf[2] = 44;          // Code décimal de l'espace
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
   }
      if (key == '@')       // Enter
   {
      buf[2] = 40;          // Code décimal de Enter
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
   }
      if (key == '%')       // Break (ESCAPE)
   {
      buf[2] = 41;          // Code décimal de Break (ESCAPE)
      Serial.write(buf, 8); // écriture sur USB
      releaseKey();         // RAZ buffer
   }                                       
}
//**************** FIN de BOUCLE **************************
//*********************************************************    
// Routine d'effacement du buffer
void releaseKey() 
{
  buf[0] = 0;
  buf[2] = 0;
  Serial.write(buf, 8);  
}
//*********************************************************    
